part of '../bmcommons.dart';

extension DateExtension on DateTime {
  String toShort() {
    if (this == null) return null;
    return this.withFormat('dd/MM/yyyy');
  }

  String toMedium() {
    if (this == null) return null;
    return DateFormat.yMMMMEEEEd().format(this);
  }

  String toLong() {
    if (this == null) return null;
    return DateFormat.yMEd().format(this);
  }

  String withFormat(format) {
    if (this == null) return null;
    return DateFormat(format).format(this);
  }
}
