import 'dart:convert';

import 'package:bmcommons/purchase/purchase.dart';
import 'package:flutter/foundation.dart';
import 'package:shared_preferences/shared_preferences.dart';

class PurchasesLocalRepository {
  final SharedPreferences prefs;

  PurchasesLocalRepository(this.prefs);

  Future<List<Purchase>> getPurchases() async {
    String res = prefs.get('purchases');
    if (res == null) return [];
    List<String> purchases = List.from(json.decode(res));
    print(purchases);
    return purchases.map((e) => Purchase.fromJson(e)).toList();
  }

  savePurchase({@required String purchase}) async {
    var purchases = (await getPurchases()).map((e) => e.toJson()).toList();
    purchases.add(purchase);
    await prefs.setString('purchases', json.encode(purchases));
  }
}
